Sign in Start for free

Deployment Settings

Get deployment settings by ID

GET /api/{spaceId}/projects/{projectId}/deploymentsettings

Also reachable at /api/projects/{projectId}/deploymentsettings, /api/spaces/{spaceIdentifier}/projects/{projectId}/deploymentsettings.

Path Parameters

  • projectId string (required)
    The Project ID to get the deployment settings from. Example Projects-1.
  • spaceId string (required)

Response

200 — The requested Deployment Settings.

  • CancelQueuedTasks boolean
  • CancelRunningTasks boolean
  • ConnectivityPolicy object
    • AllowDeploymentsToNoTargets boolean
    • ExcludeUnhealthyTargets boolean
    • SkipMachineBehavior enum
      Allowed values: None, SkipUnavailableMachines.
    • TargetRoles array of string
  • DefaultGuidedFailureMode enum
    Allowed values: EnvironmentDefault, Off, On.
  • DefaultToSkipIfAlreadyInstalled boolean
  • DeploymentChangesTemplate string
  • FailTargetDiscovery boolean
  • ForcePackageDownload boolean
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectId string
  • ReleaseNotesTemplate string
  • SpaceId string
  • VersioningStrategy object
    • DonorPackage object
    • Template string

Example Response

JSON
{
  "CancelQueuedTasks": true,
  "CancelRunningTasks": true,
  "ConnectivityPolicy": {
    "AllowDeploymentsToNoTargets": true,
    "ExcludeUnhealthyTargets": true,
    "SkipMachineBehavior": "None",
    "TargetRoles": [
      "string"
    ]
  },
  "DefaultGuidedFailureMode": "EnvironmentDefault",
  "DefaultToSkipIfAlreadyInstalled": true,
  "DeploymentChangesTemplate": "string",
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectId": "string",
  "ReleaseNotesTemplate": "string",
  "SpaceId": "string",
  "VersioningStrategy": {
    "DonorPackage": {
      "DeploymentAction": "string",
      "PackageReference": "string"
    },
    "Template": "string"
  }
}

Get deployment settings by ID

GET /api/{spaceId}/projects/{projectId}/{gitRef}/deploymentsettings

Also reachable at /api/projects/{projectId}/{gitRef}/deploymentsettings, /api/spaces/{spaceIdentifier}/projects/{projectId}/{gitRef}/deploymentsettings.

Path Parameters

  • gitRef string (required)
  • projectId string (required)
    The Project ID to get the deployment settings from. Example Projects-1.
  • spaceId string (required)

Response

200 — The requested Deployment Settings.

  • CancelQueuedTasks boolean
  • CancelRunningTasks boolean
  • ConnectivityPolicy object
    • AllowDeploymentsToNoTargets boolean
    • ExcludeUnhealthyTargets boolean
    • SkipMachineBehavior enum
      Allowed values: None, SkipUnavailableMachines.
    • TargetRoles array of string
  • DefaultGuidedFailureMode enum
    Allowed values: EnvironmentDefault, Off, On.
  • DefaultToSkipIfAlreadyInstalled boolean
  • DeploymentChangesTemplate string
  • FailTargetDiscovery boolean
  • ForcePackageDownload boolean
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectId string
  • ReleaseNotesTemplate string
  • SpaceId string
  • VersioningStrategy object
    • DonorPackage object
    • Template string

Example Response

JSON
{
  "CancelQueuedTasks": true,
  "CancelRunningTasks": true,
  "ConnectivityPolicy": {
    "AllowDeploymentsToNoTargets": true,
    "ExcludeUnhealthyTargets": true,
    "SkipMachineBehavior": "None",
    "TargetRoles": [
      "string"
    ]
  },
  "DefaultGuidedFailureMode": "EnvironmentDefault",
  "DefaultToSkipIfAlreadyInstalled": true,
  "DeploymentChangesTemplate": "string",
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectId": "string",
  "ReleaseNotesTemplate": "string",
  "SpaceId": "string",
  "VersioningStrategy": {
    "DonorPackage": {
      "DeploymentAction": "string",
      "PackageReference": "string"
    },
    "Template": "string"
  }
}

Modify deployment settings

PUT /api/{spaceId}/projects/{projectId}/{gitRef}/deploymentsettings

Also reachable at /api/projects/{projectId}/{gitRef}/deploymentsettings, /api/spaces/{spaceIdentifier}/projects/{projectId}/{gitRef}/deploymentsettings.

Modifies deployment settings for a project.

Path Parameters

  • gitRef string (required)
    Git reference to use when modifying deployment settings.
  • projectId string (required)
    The Project ID to get the deployment settings from. Example Projects-1.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • CancelQueuedTasks boolean
    When enabled, creating a new deployment will cancel all previously queued deployments to the same project/environment/tenant.
  • CancelRunningTasks boolean
    When enabled, completing a deployment will cancel older running or paused deployments to the same project/environment/tenant.
  • ChangeDescription string
    Used as the Git commit message. Omit to use the default message ‘Update deployment settings’.
  • ConnectivityPolicy object
    • AllowDeploymentsToNoTargets boolean
    • ExcludeUnhealthyTargets boolean
    • SkipMachineBehavior enum
      Allowed values: None, SkipUnavailableMachines.
    • TargetRoles array of string
  • DefaultGuidedFailureMode enum
    The action related to when a deployment error occurs. (IE: Enabling guided failure will pause the deployment failure to allow error correction before proceeding).
    Allowed values: EnvironmentDefault, Off, On.
  • DefaultToSkipIfAlreadyInstalled boolean
    If true, and the version of the package being deployed is already present on the machine, its re-deployment will be skipped.
  • DeploymentChangesTemplate string
    A markdown template generated for each deployment’s changes.
  • FailTargetDiscovery boolean
    Option to fail a step if no matching targets found in cloud discovery steps.
  • ForcePackageDownload boolean
    Option to force re-downloading packages for deployment.
  • GitRef string (required)
    Git reference to use when modifying deployment settings.
  • ProjectId string (required)
    The Project ID to get the deployment settings from. Example Projects-1.
  • ReleaseNotesTemplate string
    Template text pre-filled as the release notes when a release of this project is created; may contain Octopus variable expressions. Omitting this clears the project’s existing template.
  • SpaceId string (required)
    The ID of the space containing the resource(s).
  • VersioningStrategy object
    • DonorPackage object
    • Template string

Response

200 — Confirmation that the Deployment Settings were modified, contains the updated Deployment Settings

  • CancelQueuedTasks boolean
  • CancelRunningTasks boolean
  • ConnectivityPolicy object
    • AllowDeploymentsToNoTargets boolean
    • ExcludeUnhealthyTargets boolean
    • SkipMachineBehavior enum
      Allowed values: None, SkipUnavailableMachines.
    • TargetRoles array of string
  • DefaultGuidedFailureMode enum
    Allowed values: EnvironmentDefault, Off, On.
  • DefaultToSkipIfAlreadyInstalled boolean
  • DeploymentChangesTemplate string
  • FailTargetDiscovery boolean
  • ForcePackageDownload boolean
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectId string
  • ReleaseNotesTemplate string
  • SpaceId string
  • VersioningStrategy object
    • DonorPackage object
    • Template string

Example Request

JSON
{
  "CancelQueuedTasks": true,
  "CancelRunningTasks": true,
  "ChangeDescription": "string",
  "ConnectivityPolicy": {
    "AllowDeploymentsToNoTargets": true,
    "ExcludeUnhealthyTargets": true,
    "SkipMachineBehavior": "None",
    "TargetRoles": [
      "string"
    ]
  },
  "DefaultGuidedFailureMode": "EnvironmentDefault",
  "DefaultToSkipIfAlreadyInstalled": true,
  "DeploymentChangesTemplate": "string",
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "GitRef": "string",
  "ProjectId": "string",
  "ReleaseNotesTemplate": "string",
  "SpaceId": "string",
  "VersioningStrategy": {
    "DonorPackage": {
      "DeploymentAction": "string",
      "PackageReference": "string"
    },
    "Template": "string"
  }
}

Example Response

JSON
{
  "CancelQueuedTasks": true,
  "CancelRunningTasks": true,
  "ConnectivityPolicy": {
    "AllowDeploymentsToNoTargets": true,
    "ExcludeUnhealthyTargets": true,
    "SkipMachineBehavior": "None",
    "TargetRoles": [
      "string"
    ]
  },
  "DefaultGuidedFailureMode": "EnvironmentDefault",
  "DefaultToSkipIfAlreadyInstalled": true,
  "DeploymentChangesTemplate": "string",
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectId": "string",
  "ReleaseNotesTemplate": "string",
  "SpaceId": "string",
  "VersioningStrategy": {
    "DonorPackage": {
      "DeploymentAction": "string",
      "PackageReference": "string"
    },
    "Template": "string"
  }
}

Get deployment settings by ID

GET /api/{spaceId}/deploymentsettings/{id}

Also reachable at /api/deploymentsettings/{id}, /api/spaces/{spaceIdentifier}/deploymentsettings/{id}.

Deprecated. This endpoint may be removed in a future release.

Path Parameters

  • id string (required)
    ID of the DeploymentSettings to load.
  • spaceId string (required)

Response

200 — Success

  • CancelQueuedTasks boolean
  • CancelRunningTasks boolean
  • ConnectivityPolicy object
    • AllowDeploymentsToNoTargets boolean
    • ExcludeUnhealthyTargets boolean
    • SkipMachineBehavior enum
      Allowed values: None, SkipUnavailableMachines.
    • TargetRoles array of string
  • DefaultGuidedFailureMode enum
    Allowed values: EnvironmentDefault, Off, On.
  • DefaultToSkipIfAlreadyInstalled boolean
  • DeploymentChangesTemplate string
  • FailTargetDiscovery boolean
  • ForcePackageDownload boolean
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectId string
  • ReleaseNotesTemplate string
  • SpaceId string
  • VersioningStrategy object
    • DonorPackage object
    • Template string

Example Response

JSON
{
  "CancelQueuedTasks": true,
  "CancelRunningTasks": true,
  "ConnectivityPolicy": {
    "AllowDeploymentsToNoTargets": true,
    "ExcludeUnhealthyTargets": true,
    "SkipMachineBehavior": "None",
    "TargetRoles": [
      "string"
    ]
  },
  "DefaultGuidedFailureMode": "EnvironmentDefault",
  "DefaultToSkipIfAlreadyInstalled": true,
  "DeploymentChangesTemplate": "string",
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectId": "string",
  "ReleaseNotesTemplate": "string",
  "SpaceId": "string",
  "VersioningStrategy": {
    "DonorPackage": {
      "DeploymentAction": "string",
      "PackageReference": "string"
    },
    "Template": "string"
  }
}

Modify deployment settings

PUT /api/{spaceId}/deploymentsettings/{projectId}

Also reachable at /api/deploymentsettings/{projectId}, /api/projects/{projectId}/deploymentsettings, /api/spaces/{spaceIdentifier}/deploymentsettings/{projectId}, /api/spaces/{spaceIdentifier}/projects/{projectId}/deploymentsettings, /api/{spaceId}/projects/{projectId}/deploymentsettings.

Deprecated. This endpoint may be removed in a future release.

Modifies deployment settings for a project.

Path Parameters

  • projectId string (required)
    The Project ID to get the deployment settings from. Example Projects-1.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • CancelQueuedTasks boolean
    When enabled, creating a new deployment will cancel all previously queued deployments to the same project/environment/tenant.
  • CancelRunningTasks boolean
    When enabled, completing a deployment will cancel older running or paused deployments to the same project/environment/tenant.
  • ChangeDescription string
    The description for the deployment settings modification.
  • ConnectivityPolicy object
    • AllowDeploymentsToNoTargets boolean
    • ExcludeUnhealthyTargets boolean
    • SkipMachineBehavior enum
      Allowed values: None, SkipUnavailableMachines.
    • TargetRoles array of string
  • DefaultGuidedFailureMode enum
    The action related to when a deployment error occurs. (IE: Enabling guided failure will pause the deployment failure to allow error correction before proceeding).
    Allowed values: EnvironmentDefault, Off, On.
  • DefaultToSkipIfAlreadyInstalled boolean
    If true, and the version of the package being deployed is already present on the machine, its re-deployment will be skipped.
  • DeploymentChangesTemplate string
    A markdown template generated for each deployment’s changes.
  • FailTargetDiscovery boolean
    Fail cloud discovery steps if no targets found.
  • ForcePackageDownload boolean
    Option to force re-downloading packages for deployment.
  • ProjectId string (required)
    The Project ID to get the deployment settings from. Example Projects-1.
  • ReleaseNotesTemplate string
    Template text pre-filled as the release notes when a release of this project is created; may contain Octopus variable expressions. Omitting this clears the project’s existing template.
  • SpaceId string (required)
    The ID of the space containing the resource(s).
  • VersioningStrategy object
    • DonorPackage object
    • Template string

Response

200 — Confirmation that the Deployment Settings were modified, contains the updated Deployment Settings

  • CancelQueuedTasks boolean
  • CancelRunningTasks boolean
  • ConnectivityPolicy object
    • AllowDeploymentsToNoTargets boolean
    • ExcludeUnhealthyTargets boolean
    • SkipMachineBehavior enum
      Allowed values: None, SkipUnavailableMachines.
    • TargetRoles array of string
  • DefaultGuidedFailureMode enum
    Allowed values: EnvironmentDefault, Off, On.
  • DefaultToSkipIfAlreadyInstalled boolean
  • DeploymentChangesTemplate string
  • FailTargetDiscovery boolean
  • ForcePackageDownload boolean
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectId string
  • ReleaseNotesTemplate string
  • SpaceId string
  • VersioningStrategy object
    • DonorPackage object
    • Template string

Example Request

JSON
{
  "CancelQueuedTasks": true,
  "CancelRunningTasks": true,
  "ChangeDescription": "string",
  "ConnectivityPolicy": {
    "AllowDeploymentsToNoTargets": true,
    "ExcludeUnhealthyTargets": true,
    "SkipMachineBehavior": "None",
    "TargetRoles": [
      "string"
    ]
  },
  "DefaultGuidedFailureMode": "EnvironmentDefault",
  "DefaultToSkipIfAlreadyInstalled": true,
  "DeploymentChangesTemplate": "string",
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "ProjectId": "string",
  "ReleaseNotesTemplate": "string",
  "SpaceId": "string",
  "VersioningStrategy": {
    "DonorPackage": {
      "DeploymentAction": "string",
      "PackageReference": "string"
    },
    "Template": "string"
  }
}

Example Response

JSON
{
  "CancelQueuedTasks": true,
  "CancelRunningTasks": true,
  "ConnectivityPolicy": {
    "AllowDeploymentsToNoTargets": true,
    "ExcludeUnhealthyTargets": true,
    "SkipMachineBehavior": "None",
    "TargetRoles": [
      "string"
    ]
  },
  "DefaultGuidedFailureMode": "EnvironmentDefault",
  "DefaultToSkipIfAlreadyInstalled": true,
  "DeploymentChangesTemplate": "string",
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectId": "string",
  "ReleaseNotesTemplate": "string",
  "SpaceId": "string",
  "VersioningStrategy": {
    "DonorPackage": {
      "DeploymentAction": "string",
      "PackageReference": "string"
    },
    "Template": "string"
  }
}